﻿// arrowHead-.jsx
main();
function main()
{
var myLine;
    if (app.documents.length > 0 && app.selection.length > 0)    
    {    
        if(app.transformPreferences.whenScaling == WhenScalingOptions.APPLY_TO_CONTENT)
        {
            var n = app.selection.length;
            var myScaleMatrixL = app.transformationMatrices.add({horizontalScaleFactor:.5, verticalScaleFactor:.5});
            var myScaleMatrixH = app.transformationMatrices.add({horizontalScaleFactor:2, verticalScaleFactor:2});
            for(var i = 0; i < n; i++)
            {
			if(app.selection[i].constructor.name == "GraphicLine" || app.selection[i].constructor.name == "Polygon")
                {
                    myLine = app.selection[i];
				  if(   isArrowYN(myLine)   ) // если есть стрелка ...
                    {
                        var myXY = getPointsXY(myLine);
                        app.transformPreferences.whenScaling = WhenScalingOptions.ADJUST_SCALING_PERCENTAGE;
                        myLine.transform(CoordinateSpaces.pasteboardCoordinates, AnchorPoint.centerAnchor, myScaleMatrixL); 
                        app.transformPreferences.whenScaling = WhenScalingOptions.APPLY_TO_CONTENT;
                        myLine.transform(CoordinateSpaces.pasteboardCoordinates, AnchorPoint.centerAnchor, myScaleMatrixH);
                        restorePointsXY(myLine, myXY);
                    }
                }//if
            } // for
        }
    } // ifi(app.documents.length >0....
} // main

function isArrowYN(myLine)
{
    if(myLine.leftLineEnd.ArrowHead == ArrowHead.NONE && myLine.rightLineEnd.ArrowHead == ArrowHead.NONE) return false;
    return true;
} // fnc

function getPointsXY(myObject)
{
	var myX1, myY1, myX2, myY2, myX3, myY3;
	var myPath, myPoint;
    for(var myPathCounter = 0; myPathCounter < myObject.paths.length; myPathCounter ++)
    {
        myPath = myObject.paths.item(myPathCounter);
        myPointArray = new Array;
		for (var myPathPointCounter = 0; myPathPointCounter < myPath.pathPoints.length; myPathPointCounter ++)
        {
				myX1 = myPath.pathPoints.item(myPathPointCounter).leftDirection[0];
				myY1 = myPath.pathPoints.item(myPathPointCounter).leftDirection[1];
				myX2 = myPath.pathPoints.item(myPathPointCounter).anchor[0];
				myY2 = myPath.pathPoints.item(myPathPointCounter).anchor[1];
				myX3 = myPath.pathPoints.item(myPathPointCounter).rightDirection[0];
				myY3 = myPath.pathPoints.item(myPathPointCounter).rightDirection[1];
				myPoint = [[myX1, myY1], [myX2, myY2], [myX3, myY3]];
				myPointArray.push(myPoint);
        }// for
    }// for
return myPointArray;
}// fnc

function restorePointsXY(myObject, myXY)
{
var myPath;	
     for(var myPathCounter = 0; myPathCounter < myObject.paths.length; myPathCounter ++)
    {
		myPath = myObject.paths.item(myPathCounter);
		myPath.entirePath = myXY;
    }// for
}// fnc



